com.ibm.openpages.api.service

## Interface IConfigurationService

-     public interface IConfigurationService

  Provides service for OpenPages configuration specific features. The service provides API for the following features: Registry, Currency, Reporting Period, Application Text, Task Focused UI and Profiles. For all operations it is assumed that the user performing the operations has necessary permissions to do so. If not, the system will return appropriate exception messages.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `applyRLSRules()` Apply Rules
    `void` | `associateProfilesToUser(Id userId, java.util.List<Id> profileIds)` Associates a list of profiles to a user.
    `void` | `associateUsersToProfile(Id profileId, java.util.List<Id> userIds)` Associates a list of users to a profile.
    `IDashboardView` | `createDashboard(IDashboardView dashboard)` Creates a dashboard view
    `IRespView` | `createRespView(IRespView respView)` Creates a responsive view
    `void` | `deleteRespViews(java.util.Set<Id> respViewIds)` Deletes the responsive view
    `void` | `disableCurrency(ICurrency currency)` Set the state of the currency specified by the ICurrency object to disabled.
    `void` | `disableProfile(IProfile profile)` Disable the specified profile.
    `void` | `disassociateProfilesFromUser(Id userId, java.util.List<Id> profileIds)` Disassociates a list of profiles from a user.
    `void` | `disassociateUsersFromProfile(Id profileId, java.util.List<Id> userIds)` Disassociates a list of users to a profile.
    `void` | `enableCurrency(ICurrency currency)` Set the state of the currency specified by the ICurrency object to enabled.
    `void` | `enableProfile(IProfile profile)` Enable the specified profile.
    `void` | `enableRespViews(java.util.Set<Id> ids, boolean enable)` Enable/disable views with the specified IDs.
    `java.util.List<IRLSTypeDefinitionRules>` | `getAllRLSRules()` Returns list of All the rules
    `Id` | `getApplicableAdminView(ITypeDefinition typeDefinition)` Returns Id of the responsive view that is applicable to the input GRC object, or null if there is no applicable view.
    `Id` | `getApplicableAdminView(ITypeDefinition typeDefinition, java.lang.String profileName)` Returns Id of the responsive view that is applicable to the input GRC object for a specific profile, or null if there is no applicable view.
    `Id` | `getApplicableCreationView(ITypeDefinition typeDefinition, ITypeDefinition parentTypeDefinition)` Returns Id of the responsive view that is applicable to the input GRC object, or null if there is no applicable view.
    `Id` | `getApplicableCreationView(ITypeDefinition typeDefinition, ITypeDefinition parentTypeDefinition, java.lang.String profileName)` Returns Id of the responsive view that is applicable to the input GRC object, or null if there is no applicable view.
    `Id` | `getApplicableGridView(ITypeDefinition typeDefinition)` Returns Id of the responsive view that is applicable to the input GRC object, or null if there is no applicable view.
    `Id` | `getApplicableTaskView(IGRCObject grcObject)` Returns Id of the responsive view that is applicable to the input GRC object, or null if there is no applicable view.
    `ICurrency` | `getBaseCurrency()` Retrieve the base currency.
    `IConfigProperties` | `getConfigProperties()` Retrieve configuration properties.
    `IConfigurationFactory` | `getConfigurationFactory()` Get an instance of IConfigurationFactory.
    `java.util.List<ICurrency>` | `getCurrencies(boolean onlyEnabled)` Retrieves a list of ICurrency objects that are available in the configuration.
    `ICurrency` | `getCurrency(ISOCurrencyCode currencyCode)` Retrieve currency information for the specified currency code.
    `double` | `getCurrentExchangeRate(ICurrency currency)` Retrieve the current exchange rate for the currency.
    `IReportingPeriod` | `getCurrentReportingPeriod()` Returns the "current" reporting period.
    `IDashboardView` | `getDashboard(Id dashboardId, RespViewState viewState)` Returns a dashboard view
    `IDashboardView` | `getDashboard(Id profileId, java.lang.String viewName, RespViewState viewState)` Returns a dashboard view
    `DashboardList` | `getDashboards(IFindOptions options, RespViewState state)` Searches the dashboard views that meets the filter criteria with paging and sorting
    `IProfile` | `getDefaultProfile()` Returns the system's default profile.
    `double` | `getExchangeRate(ICurrency currency, java.util.Date date)` Retrieve the exchange rate for the currency on a particular date.
    `java.util.List<IExchangeRate>` | `getExchangeRateHistory(ICurrency currency)` Retrieve the exchange rate history for the currency.
    `java.util.List<IExchangeRate>` | `getExchangeRates(boolean onlyEnabled)` Retrieve the exchange rates for all currencies based on the parameter.
    `java.lang.String` | `getLocalizedApplicationText(Id keyId)` Retrieve the translated string associated with the key id.
    `java.lang.String` | `getLocalizedApplicationText(java.lang.String key)` Retrieve the translated string associated with the key.
    `java.lang.String` | `getLocalizedApplicationText(java.lang.String key, java.util.Locale locale)` Retrieve the translated string associated with the key and the locale.
    `java.util.List<IApplicationText>` | `getLocalizedApplicationTexts(java.util.Set<java.lang.String> categoryFilters)` Retrieve list of application text for the given categories, or for every category if given categoryFilters is empty.
    `java.util.List<IApplicationText>` | `getLocalizedApplicationTexts(java.util.Set<java.lang.String> categoryFilters, java.util.Locale locale)` Retrieve list of application text for given locale and for the given categories, or for every category if given categoryFilters is empty.
    `java.lang.String` | `getLocalizedErrorText(int errorCode)` Retrieve the translated error message associated with the error code.
    `IProfile` | `getPreferredProfile()` Returns the preferred profile for the current user.
    `IProfile` | `getPreferredProfile(IUser user)` Returns the preferred profile for the specified user.
    `IProfile` | `getProfile(Id profileId)` Returns the profile associated with the specified profile Identifier.
    `IProfile` | `getProfile(java.lang.String name)` Returns the profile associated with the specified profile name.
    `java.util.List<IProfileFieldDefinition>` | `getProfileFields(java.lang.String profileName, java.lang.String objectName, java.lang.String viewName)` Returns a list of profile field definitions for a specific view in a profile.
    `java.util.List<IProfile>` | `getProfiles()` Returns the list of profiles available in the system.
    `java.util.List<IProfile>` | `getProfiles(IUser user)` Returns the list of profiles associated with the specified user.
    `IReportingPeriod` | `getReportingPeriod(java.lang.String reportingPeriodLabel)` Returns a specific reporting period.
    `java.util.List<IReportingPeriod>` | `getReportingPeriods()` Retrieve Reporting Periods
    `IRespView` | `getRespView(Id respViewId, RespViewState viewState)` Returns a responsive view
    `IRespView` | `getRespView(ITypeDefinition typeDefinition, RespViewType viewType, java.lang.String viewName, RespViewState viewState)` Returns a responsive view
    `IRespView` | `getRespViewForWFActivity(IWFActivity activity, Id resourceContentTypeId, RespViewState viewState)` Returns a responsive view
    `RespViewList` | `getRespViews(IFindOptions options, RespViewState state)` Searches the responsive views that meets the filter criteria with paging and sorting
    `java.util.List<IRespView>` | `getRespViews(RespViewFilter filter)` Searches the responsive views that meets the filter criteria
    `IRLSTypeDefinitionRules` | `getRLSRules(ITypeDefinition ITypeDefinition)` Return a Rule for a specific contentTypeID
    `void` | `integrateCognosService()` Integrate with Cognos Service
    `boolean` | `isAdminMode()` Returns whether Administrator mode is enabled or disabled.
    `IDashboardView` | `publishDashboard(Id dashboardId)` publishes the draft state of the dashboard
    `IRespView` | `publishRespView(Id respViewId)` publishes the draft state of the view
    `void` | `refreshTraceOptions(java.util.Map<java.lang.String,java.lang.String> traceMap)` Updates the trace logging configuration based on the input.
    `void` | `reorderRespViewRules(ITypeDefinition typeDefinition, RespViewType viewType, java.util.Map<Id,java.lang.Integer> orders)` Reorder identification rules for responsive views.
    `IDashboardView` | `revertDraftDashboard(Id dashboardId)` Reverts the draft of the dashboard back to the previously published state
    `IRespView` | `revertDraftRespView(Id respViewId)` Reverts the draft of the view back to the previously published state
    `IRLSTypeDefinitionRules` | `saveRLSRules(IRLSTypeDefinitionRules rules)` Save Rules
    `void` | `setAdminMode(boolean isAdminMode)` Set whether Administrator mode should be enabled or disabled.
    `void` | `setExchangeRate(IExchangeRate exchangeRate)` Set a new exchange rate.
    `void` | `setExchangeRates(java.util.List<IExchangeRate> exchangeRates)` Set a list of exchange rates.
    `void` | `setPreferredProfile(IProfile profile)` Set the preferred profile for the current user.
    `void` | `setPreferredProfile(IProfile profile, IUser user)` Set the preferred profile for the user.
    `IDashboardView` | `updateDashboard(IDashboardView dashboard)` Updates the dashboard view
    `IRespView` | `updateRespView(IRespView respView)` Updates the responsive view

- - ### Method Detail

    - #### setAdminMode

          void setAdminMode(boolean isAdminMode)

      Set whether Administrator mode should be enabled or disabled. If true then Administrator mode will be enabled. Requires user have application permission System Admin Mode.
      Parameters:
        `isAdminMode` - - Specify true to enable and false to disable

    - #### isAdminMode

          boolean isAdminMode()

      Returns whether Administrator mode is enabled or disabled. Returns true if Administrator mode is enabled, false if disabled.
      Returns:
        true/false value.

    - #### getCurrency

          ICurrency getCurrency(ISOCurrencyCode currencyCode)

      Retrieve currency information for the specified currency code.
      Parameters:
        `currencyCode` - - Specify the ISO currency code.
      Returns:
        ICurrency object associated for the specified ISO currency code.

    - #### getCurrencies

          java.util.List<ICurrency> getCurrencies(boolean onlyEnabled)

      Retrieves a list of ICurrency objects that are available in the configuration. If parameter onlyEnabled is set to true then the list returned is only for currencies that are enabled, otherwise all currencies that are available are returned.
      Parameters:
        `onlyEnabled` - - true/false value to specify which currencies to return.
      Returns:
        List of ICurrency objects.

    - #### enableCurrency

          void enableCurrency(ICurrency currency)

      Set the state of the currency specified by the ICurrency object to enabled.
      Parameters:
        `currency` - - currency to enable.

    - #### disableCurrency

          void disableCurrency(ICurrency currency)

      Set the state of the currency specified by the ICurrency object to disabled.
      Parameters:
        `currency` - - currency to disable.

    - #### getBaseCurrency

          ICurrency getBaseCurrency()

      Retrieve the base currency.
      Returns:
        ICurrency - the base currency.

    - #### getExchangeRate

          double getExchangeRate(ICurrency currency,
                                 java.util.Date date)

      Retrieve the exchange rate for the currency on a particular date.
      Parameters:
        `currency` - - The currency to use to get the exchange rate.
        `date` - - The date for lookup.
      Returns:
        The exchange rate for the currency on the specified date.

    - #### getCurrentExchangeRate

          double getCurrentExchangeRate(ICurrency currency)

      Retrieve the current exchange rate for the currency.
      Parameters:
        `currency` - - The currency to use to get the exchange rate.
      Returns:
        The current exchange rate for the currency.

    - #### getExchangeRateHistory

          java.util.List<IExchangeRate> getExchangeRateHistory(ICurrency currency)

      Retrieve the exchange rate history for the currency.
      Parameters:
        `currency` - - The currency to use to get the exchange rate history.
      Returns:
        List consisting of a history of exchange rates for the currency.

    - #### getExchangeRates

          java.util.List<IExchangeRate> getExchangeRates(boolean onlyEnabled)

      Retrieve the exchange rates for all currencies based on the parameter.
      Parameters:
        `onlyEnabled` - - Specifies whether to get the exchange rates only for enabled currencies or all currencies. - If value is true, then exchange rates only for the enabled currencies are returned. - If value is false, then exchange rates for all currencies are returned.
      Returns:
        List of exchange rates.

    - #### getReportingPeriods

          java.util.List<IReportingPeriod> getReportingPeriods()

      Retrieve Reporting Periods
      Returns:
        a list of reporting periods.

    - #### getCurrentReportingPeriod

          IReportingPeriod getCurrentReportingPeriod()

      Returns the "current" reporting period. The current reporting period is a system invariant value used by convention. Its label should be "Current Reporting Period", both its start and end dates should be set to the same value (creation date) and its Id should be -1. The interface returned by this call is unique system wide and guaranteed to be invariant across calls.
      Returns:
        the current reporting period.

    - #### getReportingPeriod

          IReportingPeriod getReportingPeriod(java.lang.String reportingPeriodLabel)

      Returns a specific reporting period.
      Parameters:
        `reportingPeriodLabel` - - label of the reporting period to retrieve.
      Returns:
        IReportingPeriod

    - #### getLocalizedApplicationText

          java.lang.String getLocalizedApplicationText(java.lang.String key)

      Retrieve the translated string associated with the key. The locale of the current session is used for the retrieval. If there is no translated string for the locale then the return value is `null`.

      Examples:

      `String detailviewLabel = configService.getLocalizedApplicationText("com.label.activityview.detailview"); String roleTypeLabel = configService.getLocalizedApplicationText("com.label.role.type");`

      Parameters:
        `key` - - the key to the string.
      Returns:
        The translated string.

    - #### getLocalizedApplicationText

          java.lang.String getLocalizedApplicationText(Id keyId)

      Retrieve the translated string associated with the key id. The locale of the current session is used for the retrieval. If there is no translated string for the locale then the return value is `null`.
      Parameters:
        `keyId` - - the key id to the string.
      Returns:
        The translated string.

    - #### getLocalizedApplicationText

          java.lang.String getLocalizedApplicationText(java.lang.String key,
                                                       java.util.Locale locale)

      Retrieve the translated string associated with the key and the locale. If there is no translated string for the locale then the return value is `null`.

      Examples:

      `String detailviewLabel = configService.getLocalizedApplicationText("com.label.activityview.detailview", locale); String roleTypeLabel = configService.getLocalizedApplicationText("com.label.role.type", locale);`

      Parameters:
        `key` - - the key of the application string in openpages application.
        `locale` - - specified java util locale for the application string.
      Returns:
        The translated string.

    - #### getLocalizedApplicationTexts

          java.util.List<IApplicationText> getLocalizedApplicationTexts(java.util.Set<java.lang.String> categoryFilters)

      Retrieve list of application text for the given categories, or for every category if given categoryFilters is empty. The locale of the current session is used for the retrieval.
      Parameters:
        `categoryFilters` - - the set of category names to filter application texts. If this is empty, all the application texts in the system will be retrieved.
      Returns:
        The list of application text.

    - #### getLocalizedApplicationTexts

          java.util.List<IApplicationText> getLocalizedApplicationTexts(java.util.Set<java.lang.String> categoryFilters,
                                                                        java.util.Locale locale)

      Retrieve list of application text for given locale and for the given categories, or for every category if given categoryFilters is empty.
      Parameters:
        `categoryFilters` - - the set of category names to filter application texts. If this is empty, all the application texts in the system will be retrieved.
        `locale` - - specified java util locale for the application string.
      Returns:
        The list of application text.

    - #### getLocalizedErrorText

          java.lang.String getLocalizedErrorText(int errorCode)

      Retrieve the translated error message associated with the error code. The locale of the current session is used for the retrieval. If there is no translated string for the locale then the return value is `null`.
      Parameters:
        `errorCode` - - the error code.
      Returns:
        The translated string.

    - #### getConfigProperties

          IConfigProperties getConfigProperties()

      Retrieve configuration properties. Utilize this API to get to the "Settings" in OpenPages. For a specific property key, there are methods in `IConfigProperties` to check if the property exists in the system and to get the value associated with the property key.
      Returns:
        IConfigProperties object

    - #### getProfiles

          java.util.List<IProfile> getProfiles()

      Returns the list of profiles available in the system.
      Returns:
        List of IProfile objects.

    - #### getProfile

          IProfile getProfile(java.lang.String name)

      Returns the profile associated with the specified profile name.
      Parameters:
        `name` - - the profile name.
      Returns:
        IProfile object for the profile name.

    - #### getProfile

          IProfile getProfile(Id profileId)

      Returns the profile associated with the specified profile Identifier.
      Parameters:
        `profileId` - - the profile Identifier.
      Returns:
        IProfile object for the profile Identifier.
      Since:
        8.1

    - #### getProfiles

          java.util.List<IProfile> getProfiles(IUser user)

      Returns the list of profiles associated with the specified user.
      Parameters:
        `user` - - the user.
      Returns:
        List of IProfile objects.

    - #### associateUsersToProfile

          void associateUsersToProfile(Id profileId,
                                       java.util.List<Id> userIds)

      Associates a list of users to a profile.
      Parameters:
        `profileId` - - the id of the profile to get associated to the users
        `userIds` - - the list of ids for users who should be associated to the profile.

    - #### associateProfilesToUser

          void associateProfilesToUser(Id userId,
                                       java.util.List<Id> profileIds)

      Associates a list of profiles to a user.
      Parameters:
        `userId` - - the Id of the User to assign the profiles to.
        `profileIds` - - the list of profile ids for the profiles that should be associated to the user.

    - #### disassociateUsersFromProfile

          void disassociateUsersFromProfile(Id profileId,
                                            java.util.List<Id> userIds)

      Disassociates a list of users to a profile.
      Parameters:
        `profileId` - - the id of the profile to get disassociated from the users
        `userIds` - - the list of ids for users who should be disassociated from the profile.

    - #### disassociateProfilesFromUser

          void disassociateProfilesFromUser(Id userId,
                                            java.util.List<Id> profileIds)

      Disassociates a list of profiles from a user.
      Parameters:
        `userId` - - the Id of the User to disassociate the profiles from.
        `profileIds` - - the list of profile ids for the profiles that should be disassociated from the user.

    - #### setPreferredProfile

          void setPreferredProfile(IProfile profile,
                                   IUser user)

      Set the preferred profile for the user.
      Parameters:
        `profile` - - the profile to set as the preferred profile.
        `user` - - the user.

    - #### setPreferredProfile

          void setPreferredProfile(IProfile profile)

      Set the preferred profile for the current user. If the profile is not currently associated to the user, it will also be added to the user's list of associated profiles.
      Parameters:
        `profile` - - the profile to set as the preferred profile.

    - #### disableProfile

          void disableProfile(IProfile profile)

      Disable the specified profile.
      Parameters:
        `profile` - - the profile to disable.

    - #### enableProfile

          void enableProfile(IProfile profile)

      Enable the specified profile.
      Parameters:
        `profile` - - the profile to enable.

    - #### getDefaultProfile

          IProfile getDefaultProfile()

      Returns the system's default profile.
      Returns:
        The default profile.

    - #### getPreferredProfile

          IProfile getPreferredProfile()

      Returns the preferred profile for the current user.
      Returns:
        the preferred profile.

    - #### getPreferredProfile

          IProfile getPreferredProfile(IUser user)

      Returns the preferred profile for the specified user.
      Parameters:
        `user` - - the user.
      Returns:
        the preferred profile.

    - #### getProfileFields

          java.util.List<IProfileFieldDefinition> getProfileFields(java.lang.String profileName,
                                                                   java.lang.String objectName,
                                                                   java.lang.String viewName)

      Returns a list of profile field definitions for a specific view in a profile.
      Parameters:
        `profileName` - - profile name. (Required)
        `objectName` - - object name that is used in the profile. (Required)
        `viewName` - - view name. (Required)
      Returns:
        IProfileFieldDefinition - list of fields used in the specific profile view.

    - #### getRLSRules

          IRLSTypeDefinitionRules getRLSRules(ITypeDefinition ITypeDefinition)

      Return a Rule for a specific contentTypeID
      Parameters:
        `contentTypeId` -
      Returns:

    - #### getAllRLSRules

          java.util.List<IRLSTypeDefinitionRules> getAllRLSRules()

      Returns list of All the rules
      Returns:

    - #### saveRLSRules

          IRLSTypeDefinitionRules saveRLSRules(IRLSTypeDefinitionRules rules)

      Save Rules
      Parameters:
        `rules` -
      Returns:

    - #### applyRLSRules

          void applyRLSRules()

      Apply Rules

    - #### setExchangeRates

          void setExchangeRates(java.util.List<IExchangeRate> exchangeRates)

      Set a list of exchange rates.
      Parameters:
        `exchangeRates` - - a list of exchangeRates to set.

    - #### setExchangeRate

          void setExchangeRate(IExchangeRate exchangeRate)

      Set a new exchange rate.

      Example:
      `IServiceFactory factory = ServiceFactory.getServiceFactory(context); IConfigurationService configService = factory.createConfigurationService(); String currencyCode = "CAD"; double rate = 0.8636; Date startDate = null; // means current date. IExchangeRate exchangeRate = configService.getConfigurationFactory().createExchangeRate(configService, currencyCode, rate, startDate); configService.setExchangeRate(exchangeRate);`
      Parameters:
        `exchangeRate` - - the exchangeRate to set.

    - #### getConfigurationFactory

          IConfigurationFactory getConfigurationFactory()

      Get an instance of IConfigurationFactory.
      Returns:
        the instance of IConfigurationFactory

    - #### createRespView

          IRespView createRespView(IRespView respView)

      Creates a responsive view
      Parameters:
        `respView` - the view to persist
      Returns:
      Since:
        8.0.0.1

    - #### getRespViewForWFActivity

          IRespView getRespViewForWFActivity(IWFActivity activity,
                                             Id resourceContentTypeId,
                                             RespViewState viewState)

      Returns a responsive view
      Parameters:
        `activity` - the activity with view overrides
        `resourceContentTypeId` - the resource content type (required for fetching view)
        `viewState` - the state of the responsive view to retrieve
      Returns:
      Since:
        8.0.0.2

    - #### getRespView

          IRespView getRespView(Id respViewId,
                                RespViewState viewState)

      Returns a responsive view
      Parameters:
        `respViewId` - the Id of the responsive view to look up
        `viewState` - the state of the responsive view to retrieve
      Returns:
      Since:
        8.0.0.1

    - #### getRespView

          IRespView getRespView(ITypeDefinition typeDefinition,
                                RespViewType viewType,
                                java.lang.String viewName,
                                RespViewState viewState)

      Returns a responsive view
      Parameters:
        `typeDefinition` - the type definition of the responsive view to look up
        `viewType` - the type of the responsive view to look up
        `viewName` - the name of the responsive view to look up
        `viewState` - the state of the responsive view to retrieve
      Returns:
      Since:
        8.0.0.1

    - #### updateRespView

          IRespView updateRespView(IRespView respView)

      Updates the responsive view
      Parameters:
        `respView` - the view to persist
      Returns:
        the draft state of the responsive view
      Since:
        8.0.0.1

    - #### publishRespView

          IRespView publishRespView(Id respViewId)

      publishes the draft state of the view
      Parameters:
        `respViewId` - the Id of the responsive view to publish
      Returns:
        the published state of the responsive view
      Since:
        8.0.0.1

    - #### revertDraftRespView

          IRespView revertDraftRespView(Id respViewId)

      Reverts the draft of the view back to the previously published state
      Parameters:
        `respViewId` - the Id of the responsive view to revert
      Returns:
        the published state of the responsive view
      Since:
        8.0.0.1

    - #### deleteRespViews

          void deleteRespViews(java.util.Set<Id> respViewIds)

      Deletes the responsive view
      Parameters:
        `respViewIds` - Set of the Ids of the responsive view to delete
      Since:
        8.0.0.1

    - #### getRespViews

          java.util.List<IRespView> getRespViews(RespViewFilter filter)

      Searches the responsive views that meets the filter criteria
      Parameters:
        `filter` - the filter to search responsive views
      Returns:
        the list of responsive views that meet the filter criteria.
      Since:
        8.0.0.1

    - #### getRespViews

          RespViewList getRespViews(IFindOptions options,
                                    RespViewState state)

      Searches the responsive views that meets the filter criteria with paging and sorting
      Parameters:
        `filter` - - the filter to search responsive views
        `state` - - the state to fetch in the query result
      Returns:
        the list of responsive views and total count.
      Since:
        8.0.0.1

    - #### reorderRespViewRules

          void reorderRespViewRules(ITypeDefinition typeDefinition,
                                    RespViewType viewType,
                                    java.util.Map<Id,java.lang.Integer> orders)

      Reorder identification rules for responsive views. Views are reordered among the same type definition and the same responsive view type.
      Parameters:
        `typeDefinition` - - the type definition of the responsive views
        `viewType` - - the responsive view type
        `orders` - - the map object from the responsive view Id to the new order value. The map does not necessarily have to contain all the views with the same type definition and the same view type.
      Since:
        8.0.0.1

    - #### getApplicableTaskView

          Id getApplicableTaskView(IGRCObject grcObject)

      Returns Id of the responsive view that is applicable to the input GRC object, or null if there is no applicable view. The view identification rule ( that is defined by `IRespViewRuleCondition` ) is evaluated based on the rule order ( `IRespView.getRuleOrder()` ). And first matching view is returned by this API. If there is a default view, it is returned when there is no matching view based on the identification rule.
      Parameters:
        `grcObject` - to evaluate the view identification rule for.
      Returns:
        of the responsive view
      Since:
        8.0.0.1

    - #### getApplicableGridView

          Id getApplicableGridView(ITypeDefinition typeDefinition)

      Returns Id of the responsive view that is applicable to the input GRC object, or null if there is no applicable view. The view identification rule ( that is defined by `IRespViewRuleCondition` ) is evaluated based on the rule order ( `IRespView.getRuleOrder()` ). And first matching view is returned by this API. If there is a default view, it is returned when there is no matching view based on the identification rule.
      Parameters:
        `typeDefinition` - to evaluate the view identification rule for.
      Returns:
        of the responsive view
      Since:
        8.2

    - #### getApplicableAdminView

          Id getApplicableAdminView(ITypeDefinition typeDefinition)

      Returns Id of the responsive view that is applicable to the input GRC object, or null if there is no applicable view. The view identification rule ( that is defined by `IRespViewRuleCondition` ) is evaluated based on the rule order ( `IRespView.getRuleOrder()` ). And first matching view is returned by this API. If there is a default view, it is returned when there is no matching view based on the identification rule.
      Parameters:
        `typeDefinition` - to evaluate the view identification rule for.
      Returns:
        of the responsive view
      Since:
        8.3

    - #### getApplicableAdminView

          Id getApplicableAdminView(ITypeDefinition typeDefinition,
                                    java.lang.String profileName)

      Returns Id of the responsive view that is applicable to the input GRC object for a specific profile, or null if there is no applicable view. The view identification rule ( that is defined by `IRespViewRuleCondition` ) is evaluated based on the rule order ( `IRespView.getRuleOrder()` ). And first matching view is returned by this API. If there is a default view, it is returned when there is no matching view based on the identification rule.
      Parameters:
        `typeDefinition` - to evaluate the view identification rule for.
        `profileName` - to evaluate instead of the users default profile.
      Returns:
        of the responsive view
      Since:
        8.3

    - #### getApplicableCreationView

          Id getApplicableCreationView(ITypeDefinition typeDefinition,
                                       ITypeDefinition parentTypeDefinition)

      Returns Id of the responsive view that is applicable to the input GRC object, or null if there is no applicable view. The view identification rule ( that is defined by `IRespViewRuleCondition` ) is evaluated based on the rule order ( `IRespView.getRuleOrder()` ). And first matching view is returned by this API. If there is a default view, it is returned when there is no matching view based on the identification rule.
      Parameters:
        `typeDefinition` - to evaluate the view identification rule for.
        `parentTypeDefinition` - for the intended parent type of the type to be created. (Optional)
      Returns:
        of the responsive view
      Since:
        8.2

    - #### getApplicableCreationView

          Id getApplicableCreationView(ITypeDefinition typeDefinition,
                                       ITypeDefinition parentTypeDefinition,
                                       java.lang.String profileName)

      Returns Id of the responsive view that is applicable to the input GRC object, or null if there is no applicable view. The view identification rule ( that is defined by `IRespViewRuleCondition` ) is evaluated based on the rule order ( `IRespView.getRuleOrder()` ). And first matching view is returned by this API. If there is a default view, it is returned when there is no matching view based on the identification rule.
      Parameters:
        `typeDefinition` - to evaluate the view identification rule for.
        `parentTypeDefinition` - for the intended parent type of the type to be created. (Optional)
        `profileName` - to evaluate instead of the users default profile.
      Returns:
        of the responsive view
      Since:
        8.3

    - #### enableRespViews

          void enableRespViews(java.util.Set<Id> ids,
                               boolean enable)

      Enable/disable views with the specified IDs. This is a bulk operation that either completely succeeds or fails; ie, there will be no partial updates
      Parameters:
        `ids` - The view IDs to enable/disable
        `enable` - TRUE enables the views; FALSE disables the views

    - #### getDashboard

          IDashboardView getDashboard(Id dashboardId,
                                      RespViewState viewState)

      Returns a dashboard view
      Parameters:
        `dashboardId` - the Id of the dashboard view to look up
        `viewState` - the state of the dashboard view to retrieve
      Returns:
      Since:
        8.1

    - #### getDashboard

          IDashboardView getDashboard(Id profileId,
                                      java.lang.String viewName,
                                      RespViewState viewState)

      Returns a dashboard view
      Parameters:
        `profileId` - the Id of the Object Profile that the dashboard is associated to
        `viewName` - the name of the dashboard view to look up
        `viewState` - the state of the dashboard view to retrieve
      Returns:
      Since:
        8.1

    - #### createDashboard

          IDashboardView createDashboard(IDashboardView dashboard)

      Creates a dashboard view
      Parameters:
        `dashboard` - - The view to persist
      Returns:
      Since:
        8.1

    - #### getDashboards

          DashboardList getDashboards(IFindOptions options,
                                      RespViewState state)

      Searches the dashboard views that meets the filter criteria with paging and sorting
      Parameters:
        `filter` - the filter to search dashboard views
      Returns:
        the list of dashboard views and total count.
      Since:
        8.1

    - #### updateDashboard

          IDashboardView updateDashboard(IDashboardView dashboard)

      Updates the dashboard view
      Parameters:
        `dashboard` - the view to persist
      Returns:
        the draft state of the dashboard view
      Since:
        8.1

    - #### publishDashboard

          IDashboardView publishDashboard(Id dashboardId)

      publishes the draft state of the dashboard
      Parameters:
        `dashboardId` - the Id of the dashboard view to publish
      Returns:
        the published state of the dashboard view
      Since:
        8.1

    - #### revertDraftDashboard

          IDashboardView revertDraftDashboard(Id dashboardId)

      Reverts the draft of the dashboard back to the previously published state
      Parameters:
        `dashboardId` - the Id of the dashboard view to revert
      Returns:
        the published state of the dashboard view
      Since:
        8.1

    - #### refreshTraceOptions

          void refreshTraceOptions(java.util.Map<java.lang.String,java.lang.String> traceMap)

      Updates the trace logging configuration based on the input. The registry entries and auroralogging.properties are updated based on the trace inputs and the configuration is reloaded dynamically. When this is invoked for the first time, the original auroralogging.properties is backed up as auroralogging-backup.properties. This operation is enabled only when "/OpenPages/Applications/Common/Administration/Enable Manage Trace Options" registry setting is set "true", otherwise, auroralogging.properties is updated by hand manually outside of this API call.
      Parameters:
        `traceMap` - - map of trace entries whose key is the registry entry name under "OpenPages/Applications/Common/Administration/Trace" and value is either "true" or "false"
      Since:
        8.3

    - #### integrateCognosService

          void integrateCognosService()

      Integrate with Cognos Service
      Since:
        8.2.0.4

Licensed Materials - Property of IBM
OpenPages with Watson (PID: 5725-D51)
© Copyright IBM Corporation 2013, 2022. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.